#!/usr/bin/env python

import os, sys, re

# os.makedirs is broken
# here's our own
def makedirs(dirname, mode=0777):
    parts = dirname.split(os.path.sep)
    for i in range(len(parts)):
        path_so_far = os.path.join(*parts[:i+1])
        if not os.path.exists(path_so_far):
            os.mkdir(path_so_far)

comment_re = re.compile(r'#.*$')
config_re = re.compile(r'(?P<name>[A-Za-z0-9_\-/]+)\s*=\s*(?P<value>[A-Za-z0-9_]+)$')
number_re = re.compile(r'^([0-9]+)|(0x[0-9A-Fa-f]+)$')

class Config(object):
    def __init__(self, conf_filename, conf_dir):
        self.conf_filename = conf_filename
        self.conf_dir = conf_dir
        self.h_files = {}
        self.dict = {}

        makedirs(conf_dir)

        f = open(conf_filename, 'r')
        line_no = 1
        for line in f.xreadlines():
            line_no += 1
            line = comment_re.sub('', line).strip()
            if line == '':
                continue
            match = config_re.match(line)
            if not match:
                print "%s:%d: syntax error" % (conf_filename, line_no)
                continue
            name = match.group('name')
            value = match.group('value')
            self.handle_config(name, value)

        self.finish()

    def handle_config(self, name, value):
        self.dict[name] = value
        name_parts = name.split('/')
        macro_name = 'CONFIG_%s' % '_'.join(name_parts).upper()

        dirname = '/'.join(name_parts[:-2])
        h_filename = '/'.join(name_parts[:-1]) + '.h'

        if dirname != '':
            makedirs(os.path.join(self.conf_dir, dirname))

        if h_filename in self.h_files:
            f = self.h_files[h_filename]
        else:
            guard_name = 'CONFIG_%s_H' % '_'.join(name_parts[:-1]).upper()
            f = open(os.path.join(self.conf_dir, h_filename), 'w')
            f.write("""\
/*
 * Automatically generated by configure.py
 * Don't edit this file - edit CONFIG instead.
 */

#ifndef %s
#define %s
""" % ((guard_name,) * 2))
            self.h_files[h_filename] = f
            
        if number_re.match(value):
            macro_value = value
        else:
            macro_value = "'%s'" % value
        f.write("#define %s %s\n" % (macro_name, macro_value))

    def finish(self):
        for h_filename, f in self.h_files.iteritems():
            f.write("#endif\n")
            f.close()
        self.h_files = None

    def get(self, key):
        if key in self.dict:
            return self.dict[key]
        else:
            print "WARNING: Setting %s not found in %s" % (key, self.conf_filename)
